ConRO.Spells = {};
ConRO.Keybinds = {};
ConRO.DefSpells = {};
ConRO.Flags = {};
ConRO.SpellsGlowing = {};
ConRO.WindowsGlowing = {};
ConRO.DefGlowing = {};
ConRO.DamageFramePool = {};
ConRO.DamageFrames = {};
ConRO.DefenseFramePool = {};
ConRO.DefenseFrames = {};
ConRO.InterruptFramePool = {};
ConRO.InterruptFrames = {};
ConRO.CoolDownFramePool = {};
ConRO.CoolDownFrames = {};
ConRO.PurgableFramePool = {};
ConRO.PurgableFrames = {};
ConRO.RaidBuffsFramePool = {};
ConRO.RaidBuffsFrames = {};
ConRO.TauntFramePool = {};
ConRO.TauntFrames = {};
ConRO.WindowFramePool = {};
ConRO.WindowFrames = {};

function TTOnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_PRESERVE")
	GameTooltip:SetText("ConRO Target Toggle")  -- This sets the top line of text, in gold.
	GameTooltip:AddLine('MACRO = "/ConROToggle"', 1, 1, 1, true)
	GameTooltip:AddLine(" ", 1, 1, 1, true)
	GameTooltip:AddLine("Single", .2, 1, .2)
		GameTooltip:AddLine("This is for single target fights.", 1, 1, 1, true)
	GameTooltip:AddLine("AoE", 1, .2, .2)
		GameTooltip:AddLine("Can be used for trash or Boss fights with frequent adds.", 1, 1, 1, true)
	GameTooltip:AddLine(" ", 1, 1, 1, true)
		GameTooltip:AddLine('"This can be toggled during combat as phases change."', 1, 1, 0, true)
	GameTooltip:Show()
end

function TTOnLeave(self)
	GameTooltip:Hide()
end

function ETOnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_PRESERVE")
	GameTooltip:SetText("ConRO Rotation Toggle")  -- This sets the top line of text, in gold.
	GameTooltip:AddLine('MACRO = "/ConROBurstToggle"', 1, 1, 1, true)
	GameTooltip:AddLine(" ", 1, 1, 1, true)
	GameTooltip:AddLine("Burst Rotation", .2, 1, .2)
		GameTooltip:AddLine("This is for Boss fights where you want to decide when to use your cooldowns.", 1, 1, 1, true)
	GameTooltip:AddLine("Full Rotation", 1, .2, .2)
		GameTooltip:AddLine("Can be used for placing long cooldowns into the recommended rotation.", 1, 1, 1, true)
	GameTooltip:AddLine(" ", 1, 1, 1, true)
		GameTooltip:AddLine('"This can be toggled during combat as phases change."', 1, 1, 0, true)
	GameTooltip:Show()
end

function ETOnLeave(self)
	GameTooltip:Hide()
end

function TWOnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_PRESERVE")
	GameTooltip:SetText("ConRO Window")  -- This sets the top line of text, in gold.
	GameTooltip:AddLine("", .2, 1, .2)
		GameTooltip:AddLine("This window displays the next suggested ability in your rotation.", 1, 1, 1, true)
	GameTooltip:Show()
end

function TWOnLeave(self)
	GameTooltip:Hide()
end

function ConRO:DisplayToggleFrame()
	local _, Class = UnitClass("player")
	local Color = RAID_CLASS_COLORS[Class]
	local frame = CreateFrame("Frame", "ConROButtonFrame", UIParent)
	local vert = 2;
	local hori = 1;
		if ConRO.db.global.toggleButtonOrientation == 1 then
			vert = 2;
			hori = 1;
		elseif ConRO.db.global.toggleButtonOrientation == 2 then
			vert = 1;
			hori = 2;
		end
		
		frame:SetFrameStrata('LOW');
		frame:SetSize((40 * hori) + 14, (15 * vert) + 14)
		frame:SetScale(ConRO.db.global.toggleButtonSize)
		frame:SetAlpha(1)
		
		frame:SetBackdrop( { 
			bgFile = "Interface\\CHATFRAME\\CHATFRAMEBACKGROUND", 
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true,
			tileSize = 8,
			edgeSize = 20, 
			insets = { left = 4, right = 4, top = 4, bottom = 4 }
			})
		frame:SetBackdropColor(0, 0, 0, .75)
		frame:SetBackdropBorderColor(Color.r, Color.g, Color.b, .75)
		
		frame:SetPoint("CENTER", 180, -20)
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:SetClampedToScreen(true)
		frame:RegisterForDrag("LeftButton")
		frame:SetScript("OnDragStart", function(self)
			if not ConRO.db.global.lockTarget then
				frame:StartMoving()
			end
		end)
		frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
		frame:Show()
end

function ConRO:CreateSingleButton()
	local _, Class = UnitClass("player")
	local Color = RAID_CLASS_COLORS[Class]
	local tbutton = CreateFrame("Button", 'ConRO_SingleButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM')
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("BOTTOMRIGHT", "ConROButtonFrame", "BOTTOMRIGHT", -7, 7)
		tbutton:SetSize(40, 15)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:Show()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("Single")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", TTOnEnter)
		tbutton:SetScript("OnLeave", TTOnLeave)
		
	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(Color.r, Color.g, Color.b, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)

	local htex = tbutton:CreateTexture()
		htex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonHighlight")
		htex:SetTexCoord(0, 0.625, 0, 0.6875)
		htex:SetAllPoints()
		tbutton:SetHighlightTexture(htex)

	local ptex = tbutton:CreateTexture()
		ptex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonDown")
		ptex:SetTexCoord(0, 0.625, 0, 0.6875)
		ptex:SetVertexColor(Color.r, Color.g, Color.b, 1)
		ptex:SetAllPoints()
		tbutton:SetPushedTexture(ptex)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
				self:Hide();
				ConRO_AoEButton:Show();
		end)
end

function ConRO:CreateAoEButton()
	local tbutton = CreateFrame("Button", 'ConRO_AoEButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("BOTTOMRIGHT", "ConROButtonFrame", "BOTTOMRIGHT", -7, 7)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:SetSize(40, 15)
		tbutton:Hide()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("AoE")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", TTOnEnter)
		tbutton:SetScript("OnLeave", TTOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(.50, .50, .50, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)

	local htex = tbutton:CreateTexture()
		htex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonHighlight")
		htex:SetTexCoord(0, 0.625, 0, 0.6875)
		htex:SetAllPoints()
		tbutton:SetHighlightTexture(htex)

	local ptex = tbutton:CreateTexture()
		ptex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonDown")
		ptex:SetTexCoord(0, 0.625, 0, 0.6875)
		ptex:SetVertexColor(.50, .50, .50, 1)
		ptex:SetAllPoints()
		tbutton:SetPushedTexture(ptex)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
				self:Hide();
				ConRO_SingleButton:Show();
		end)
end

function ConRO:CreateFullButton()
	local _, Class = UnitClass("player")
	local Color = RAID_CLASS_COLORS[Class]
	local tbutton = CreateFrame("Button", 'ConRO_FullButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("TOPLEFT", "ConROButtonFrame", "TOPLEFT", 7, -7)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:SetSize(40, 15)
		tbutton:SetAlpha(1)
		tbutton:Show();
		
		tbutton:SetText("Full")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", ETOnEnter)
		tbutton:SetScript("OnLeave", ETOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(Color.r, Color.g, Color.b, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)

	local htex = tbutton:CreateTexture()
		htex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonHighlight")
		htex:SetTexCoord(0, 0.625, 0, 0.6875)
		htex:SetAllPoints()
		tbutton:SetHighlightTexture(htex)

	local ptex = tbutton:CreateTexture()
		ptex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonDown")
		ptex:SetTexCoord(0, 0.625, 0, 0.6875)
		ptex:SetVertexColor(Color.r, Color.g, Color.b, 1)
		ptex:SetAllPoints()
		tbutton:SetPushedTexture(ptex)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
				self:Hide();
				ConRO_BurstButton:Show();
		end)
end

function ConRO:CreateBurstButton()
	local tbutton = CreateFrame("Button", 'ConRO_BurstButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("TOPLEFT", "ConROButtonFrame", "TOPLEFT", 7, -7)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:SetSize(40, 15)
		tbutton:SetAlpha(1)
		tbutton:Hide();

		tbutton:SetText("Burst")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", ETOnEnter)
		tbutton:SetScript("OnLeave", ETOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(.50, .50, .50, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)

	local htex = tbutton:CreateTexture()
		htex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonHighlight")
		htex:SetTexCoord(0, 0.625, 0, 0.6875)
		htex:SetAllPoints()
		tbutton:SetHighlightTexture(htex)

	local ptex = tbutton:CreateTexture()
		ptex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonDown")
		ptex:SetTexCoord(0, 0.625, 0, 0.6875)
		ptex:SetVertexColor(.50, .50, .50, 1)
		ptex:SetAllPoints()
		tbutton:SetPushedTexture(ptex)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
				self:Hide();
				ConRO_FullButton:Show();
		end)
end

function ConRO:CreateBlockBurstButton()
	local tbutton = CreateFrame("Button", 'ConRO_BlockBurstButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("TOPLEFT", "ConROButtonFrame", "TOPLEFT", 7, -7)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:SetSize(40, 15)
		tbutton:Hide()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("Just")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", ETOnEnter)
		tbutton:SetScript("OnLeave", ETOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(0, 0, 0, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)
end

function ConRO:CreateBlockAoEButton()
	local tbutton = CreateFrame("Button", 'ConRO_BlockAoEButton', UIParent)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("BOTTOMRIGHT", "ConROButtonFrame", "BOTTOMRIGHT", -7, 7)
		tbutton:SetScale(ConRO.db.global.toggleButtonSize)
		tbutton:SetSize(40, 15)
		tbutton:Hide()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("Kill")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", TTOnEnter)
		tbutton:SetScript("OnLeave", TTOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(0, 0, 0, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)
end

function ConRO:SlashToggle()
	if ConRO_SingleButton:IsVisible() then
		ConRO_SingleButton:Hide();
		ConRO_AoEButton:Show();
	elseif ConRO_AoEButton:IsVisible() then
		ConRO_AoEButton:Hide();
		ConRO_SingleButton:Show();
	end
end

function ConRO:SlashBurstToggle()
	if ConRO_BurstButton:IsVisible() then
		ConRO_BurstButton:Hide();
		ConRO_FullButton:Show();
	elseif ConRO_FullButton:IsVisible() then
		ConRO_FullButton:Hide();
		ConRO_BurstButton:Show();
	end
end

SLASH_CONRO1 = '/ConROtoggle'
SLASH_CONROB1 = '/ConROBurstToggle'
SlashCmdList["CONRO"] = function() ConRO:SlashToggle() end -- Slash Command List
SlashCmdList["CONROB"] = function() ConRO:SlashBurstToggle() end -- Slash Command List

function ConRO:ToggleHealer()
	ConROButtonFrame:Hide();
	ConRO_SingleButton:Hide();
	ConRO_AoEButton:Hide();
	ConRO_BurstButton:Hide();
	ConRO_FullButton:Hide();
	ConRO_BlockBurstButton:Hide();
	ConRO_BlockAoEButton:Hide();
end

function ConRO:ToggleDamage()
	ConROButtonFrame:Show();
	ConRO_SingleButton:Show();
	ConRO_AoEButton:Hide();
	if ConRO.db.global.burstDefault then
		ConRO_FullButton:Hide();
		ConRO_BurstButton:Show();
	else
		ConRO_FullButton:Show();
		ConRO_BurstButton:Hide();
	end
	ConRO_BlockBurstButton:Hide();
	ConRO_BlockAoEButton:Hide();
end

function ConRO:BlockBurst()
	ConRO_BurstButton:Hide();
	ConRO_FullButton:Hide();
	ConRO_BlockBurstButton:Show();
end

function ConRO:BlockAoE()
	ConRO_SingleButton:Hide();
	ConRO_AoEButton:Hide();
	ConRO_BlockAoEButton:Show();
end
	
function ConRO:DisplayWindowFrame()
	local frame = CreateFrame("Frame", "ConROWindow", UIParent)
	local _, _, spellTexture = GetSpellInfo(247007);
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:SetClampedToScreen(true)
		frame:RegisterForDrag("LeftButton")
		frame:SetScript("OnEnter", TWOnEnter)
		frame:SetScript("OnLeave", TWOnLeave)
		frame:SetScript("OnDragStart", function(self)
			if not ConRO.db.global.lockWindow then
				frame:StartMoving()
			end
		end)
		frame:SetScript("OnDragStop", frame.StopMovingOrSizing)

		frame:SetPoint("CENTER", -200, 50)
		frame:SetSize(ConRO.db.global.windowIconSize, ConRO.db.global.windowIconSize)
		frame:SetFrameStrata('MEDIUM');
		frame:SetFrameLevel('5');
		frame:Hide();
		
	local t = frame.texture;
		if not t then
			t = frame:CreateTexture("ARTWORK")
			t:SetTexture(spellTexture);
			t:SetBlendMode('BLEND');
			t:SetAlpha(ConRO.db.global.transparencyWindow - .2);
			frame.texture = t;
		end
		
		t:SetAllPoints(frame)
end

function ConRO:CreateDisplayWindow(parent, id)
	local frame = tremove(self.WindowFramePool);
	local spellName, _, spellTexture = GetSpellInfo(id);
	local _, Class = UnitClass("player");
	local Color = RAID_CLASS_COLORS[Class];
		if not frame then
			frame = CreateFrame('Frame', 'ConRO_WindowSpell_' .. id, parent);
			fontstring = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlight");
			fontkey = frame:CreateFontString("ConRO_HotKey", "ARTWORK", "GameFontHighlight");
		end
	
	local keybind;
			for k, button in pairs(self.Keybinds[id]) do
			
				--[[if button = 'MultiBarBottomLeftButton1'then
					button = 'MULTIACTIONBAR1BUTTON1';
				elseif button = 'MultiBarBottomRightButton1' then
					button = 'MULTIACTIONBAR2BUTTON1';
				elseif button = 'MultiBarRightButton1' then
					button = 'MULTIACTIONBAR3BUTTON1';
				if button = 'MultiBarLeftButton7' then
					button = 'MultiActionBar4Button7';
				elseif button = 'ACTIONBUTTON1' then
					button = button;
				end]]
				
				--[[keybind = GetBindingKey(button);]] -- Can't figure out keybindings yet.
			end
	
	
	frame:SetParent("ConROWindow");
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6');
	frame:SetPoint('CENTER', 0, 0);
	frame:SetSize(ConRO.db.global.windowIconSize, ConRO.db.global.windowIconSize);
	frame:SetAlpha(ConRO.db.global.transparencyWindow);
	
	fontstring:SetText(spellName);
	fontstring:SetTextColor(Color.r, Color.g, Color.b, 1);
	fontstring:SetPoint ('TOP', 0, 15);
	
	fontkey:SetParent("ConRO_WindowSpell_" .. id);
	fontkey:SetText(keybind);
	fontkey:SetPoint("BOTTOM", 0, -15);
	fontkey:SetTextColor(1, 1, 1, 1);
	
	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('WindowIcon', 'BACKGROUND');
		t:SetTexture(spellTexture);
		t:SetBlendMode('BLEND');
		frame.texture = t;
	end
	
	t:SetAllPoints(frame);

	tinsert(self.WindowFrames, frame);
	return frame;
end

function ConRO:CreateDamageOverlay(parent, id)
	local frame = tremove(self.DamageFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_DamageOverlay_' .. id, parent);
	end
	
	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6');
	frame:SetPoint('CENTER', 0, 5);
	frame:SetWidth(parent:GetWidth() * 1.6);
	frame:SetHeight(parent:GetHeight() * 1.8);
	frame:SetScale(ConRO.db.global.overlayScale);
	local alpha = 0;
	local alphaSet = ConRO.db.global.damageOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);
	
	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('GlowDamageOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\skull');
		t:SetBlendMode('ADD');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.damageOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);

	tinsert(self.DamageFrames, frame);
	return frame;
end

function ConRO:CreateDefenseOverlay(parent, id)
	local frame = tremove(self.DefenseFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_DefenseOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 1.2);
	frame:SetHeight(parent:GetHeight() * 1.4);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.defenseOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('GlowDefenseOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\shield');
		t:SetBlendMode('ADD');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.defenseOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.DefenseFrames, frame);
	return frame;
end

function ConRO:CreateInterruptOverlay(parent, id)
	local frame = tremove(self.InterruptFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_InterruptOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 1.8);
	frame:SetHeight(parent:GetHeight() * 1.8);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.notifierOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('AbilityInterruptOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\lightning');
		t:SetBlendMode('BLEND');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.interruptOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.InterruptFrames, frame);
	return frame;
end

function ConRO:CreatePurgableOverlay(parent, id)
	local frame = tremove(self.PurgableFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_PurgableOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 2);
	frame:SetHeight(parent:GetHeight() * 2);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.notifierOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('AbilityPurgeOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\magiccircle');
		t:SetBlendMode('BLEND');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.purgeOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.PurgableFrames, frame);
	return frame;
end

function ConRO:CreateTauntOverlay(parent, id)
	local frame = tremove(self.TauntFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_TauntOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 1.5);
	frame:SetHeight(parent:GetHeight() * 1.5);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.defenseOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('AbilityTauntOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\rage');
		t:SetBlendMode('BLEND');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.tauntOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.TauntFrames, frame);
	return frame;
end

function ConRO:CreateRaidBuffsOverlay(parent, id)
	local frame = tremove(self.RaidBuffsFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_RaidBuffsOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 1.5);
	frame:SetHeight(parent:GetHeight() * 1.65);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.notifierOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('AbilityRaidBuffsOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\plus');
		t:SetBlendMode('BLEND');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.raidbuffsOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.RaidBuffsFrames, frame);
	return frame;
end

function ConRO:CreateCoolDownOverlay(parent, id)
	local frame = tremove(self.CoolDownFramePool);
	if not frame then
		frame = CreateFrame('Frame', 'ConRO_CoolDownOverlay_' .. id, parent);
	end

	frame:SetParent(parent);
	frame:SetFrameStrata('MEDIUM');
	frame:SetFrameLevel('6')
	frame:SetPoint('CENTER', 0, 0);
	frame:SetWidth(parent:GetWidth() * 2);
	frame:SetHeight(parent:GetHeight() * 2);
	frame:SetScale(ConRO.db.global.overlayScale)
	local alpha = 0;
	local alphaSet = ConRO.db.global.damageOverlayAlpha;
		if alphaSet == true then
			alpha = 1;
		end
	frame:SetAlpha(alpha);

	local t = frame.texture;
	if not t then
		t = frame:CreateTexture('AbilityBurstOverlay', 'OVERLAY');
		t:SetTexture('Interface\\AddOns\\ConRO\\images\\starburst');
		t:SetBlendMode('ADD');
		frame.texture = t;
	end

	t:SetAllPoints(frame);
	local color = ConRO.db.global.cooldownOverlayColor;
	t:SetVertexColor(color.r, color.g, color.b);
	t:SetAlpha(color.a);
	
	tinsert(self.CoolDownFrames, frame);
	return frame;
end

function ConRO:DestroyWindowFrames()
	local frame;
	for key, frame in pairs(self.WindowFrames) do
		frame:GetParent().ConROWindowFrames = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.WindowFrames) do
		tinsert(self.WindowFramePool, frame);
		self.WindowFrames[key] = nil;
	end
end

function ConRO:DestroyDamageOverlays()
	local frame;
	for key, frame in pairs(self.DamageFrames) do
		frame:GetParent().ConRODamageOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.DamageFrames) do
		tinsert(self.DamageFramePool, frame);
		self.DamageFrames[key] = nil;
	end
end

function ConRO:DestroyInterruptOverlays()
	local frame;
	for key, frame in pairs(self.InterruptFrames) do
		frame:GetParent().ConROInterruptOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.InterruptFrames) do
		tinsert(self.InterruptFramePool, frame);
		self.InterruptFrames[key] = nil;
	end
end

function ConRO:DestroyPurgableOverlays()
	local frame;
	for key, frame in pairs(self.PurgableFrames) do
		frame:GetParent().ConROPurgableOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.PurgableFrames) do
		tinsert(self.PurgableFramePool, frame);
		self.PurgableFrames[key] = nil;
	end
end

function ConRO:DestroyTauntOverlays()
	local frame;
	for key, frame in pairs(self.TauntFrames) do
		frame:GetParent().ConROTauntOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.TauntFrames) do
		tinsert(self.TauntFramePool, frame);
		self.TauntFrames[key] = nil;
	end
end

function ConRO:DestroyRaidBuffsOverlays()
	local frame;
	for key, frame in pairs(self.RaidBuffsFrames) do
		frame:GetParent().ConRORaidBuffsOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.RaidBuffsFrames) do
		tinsert(self.RaidBuffsFramePool, frame);
		self.RaidBuffsFrames[key] = nil;
	end
end

function ConRO:DestroyCoolDownOverlays()
	local frame;
	for key, frame in pairs(self.CoolDownFrames) do
		frame:GetParent().ConROCoolDownOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.CoolDownFrames) do
		tinsert(self.CoolDownFramePool, frame);
		self.CoolDownFrames[key] = nil;
	end
end

function ConRO:DestroyDefenseOverlays()
	local frame;
	for key, frame in pairs(self.DefenseFrames) do
		frame:GetParent().ConRODefenseOverlays = nil;
		frame:ClearAllPoints();
		frame:Hide();
		frame:SetParent(UIParent);
		frame.width = nil;
		frame.height = nil;
		frame.alpha = nil;
	end
	for key, frame in pairs(self.DefenseFrames) do
		tinsert(self.DefenseFramePool, frame);
		self.DefenseFrames[key] = nil;
	end
end

function ConRO:UpdateButtonGlow()
	local LAB;
	local LBG;
	local origShow;
	local noFunction = function() end;

	if IsAddOnLoaded('ElvUI') then
		LAB = LibStub:GetLibrary('LibActionButton-1.0-ElvUI');
		LBG = LibStub:GetLibrary('LibButtonGlow-1.0');
		origShow = LBG.ShowOverlayGlow;
	elseif IsAddOnLoaded('Bartender4') then
		LAB = LibStub:GetLibrary('LibActionButton-1.0');
	end

	if self.db.global.disableButtonGlow then
		ActionBarActionEventsFrame:UnregisterEvent('SPELL_ACTIVATION_OVERLAY_GLOW_SHOW');
		if LAB then
			LAB.eventFrame:UnregisterEvent('SPELL_ACTIVATION_OVERLAY_GLOW_SHOW');
		end

		if LBG then
			LBG.ShowOverlayGlow = noFunction;
		end
	else
		ActionBarActionEventsFrame:RegisterEvent('SPELL_ACTIVATION_OVERLAY_GLOW_SHOW');
		if LAB then
			LAB.eventFrame:RegisterEvent('SPELL_ACTIVATION_OVERLAY_GLOW_SHOW');
		end

		if LBG then
			LBG.ShowOverlayGlow = origShow;
		end
	end
end

function ConRO:WindowGlow(frame, id)
if frame.ConROWindowFrames and frame.ConROWindowFrames[id] then
		frame.ConROWindowFrames[id]:Show();
	else
		if not frame.ConROWindowFrames then
			frame.ConROWindowFrames = {};
		end

		frame.ConROWindowFrames[id] = self:CreateDisplayWindow(frame, id);
		frame.ConROWindowFrames[id]:Show();
	end
end

function ConRO:DamageGlow(button, id)
	if button.ConRODamageOverlays and button.ConRODamageOverlays[id] then
		button.ConRODamageOverlays[id]:Show();
	else
		if not button.ConRODamageOverlays then
			button.ConRODamageOverlays = {};
		end

		button.ConRODamageOverlays[id] = self:CreateDamageOverlay(button, id);
		button.ConRODamageOverlays[id]:Show();
	end
end

function ConRO:DefenseGlow(button, id)
	if button.ConRODefenseOverlays and button.ConRODefenseOverlays[id] then
		button.ConRODefenseOverlays[id]:Show();
	else
		if not button.ConRODefenseOverlays then
			button.ConRODefenseOverlays = {};
		end

		button.ConRODefenseOverlays[id] = self:CreateDefenseOverlay(button, id);
		button.ConRODefenseOverlays[id]:Show();
	end
end

function ConRO:InterruptGlow(button, id)
	if button.ConROInterruptOverlays and button.ConROInterruptOverlays[id] then
		button.ConROInterruptOverlays[id]:Show();
	else
		if not button.ConROInterruptOverlays then
			button.ConROInterruptOverlays = {};
		end

		button.ConROInterruptOverlays[id] = self:CreateInterruptOverlay(button, id);
		button.ConROInterruptOverlays[id]:Show();
	end
end

function ConRO:PurgableGlow(button, id)
	if button.ConROPurgableOverlays and button.ConROPurgableOverlays[id] then
		button.ConROPurgableOverlays[id]:Show();
	else
		if not button.ConROPurgableOverlays then
			button.ConROPurgableOverlays = {};
		end

		button.ConROPurgableOverlays[id] = self:CreatePurgableOverlay(button, id);
		button.ConROPurgableOverlays[id]:Show();
	end
end

function ConRO:TauntGlow(button, id)
	if button.ConROTauntOverlays and button.ConROTauntOverlays[id] then
		button.ConROTauntOverlays[id]:Show();
	else
		if not button.ConROTauntOverlays then
			button.ConROTauntOverlays = {};
		end

		button.ConROTauntOverlays[id] = self:CreateTauntOverlay(button, id);
		button.ConROTauntOverlays[id]:Show();
	end
end

function ConRO:RaidBuffsGlow(button, id)
	if button.ConRORaidBuffsOverlays and button.ConRORaidBuffsOverlays[id] then
		button.ConRORaidBuffsOverlays[id]:Show();
	else
		if not button.ConRORaidBuffsOverlays then
			button.ConRORaidBuffsOverlays = {};
		end

		button.ConRORaidBuffsOverlays[id] = self:CreateRaidBuffsOverlay(button, id);
		button.ConRORaidBuffsOverlays[id]:Show();
	end
end

function ConRO:CoolDownGlow(button, id)
	if button.ConROCoolDownOverlays and button.ConROCoolDownOverlays[id] then
		button.ConROCoolDownOverlays[id]:Show();
	else
		if not button.ConROCoolDownOverlays then
			button.ConROCoolDownOverlays = {};
		end

		button.ConROCoolDownOverlays[id] = self:CreateCoolDownOverlay(button, id);
		button.ConROCoolDownOverlays[id]:Show();
	end
end

function ConRO:HideWindowGlow(frame, id)
	if frame.ConROWindowFrames and frame.ConROWindowFrames[id] then
		frame.ConROWindowFrames[id]:Hide();
	end
end

function ConRO:HideDamageGlow(button, id)
	if button.ConRODamageOverlays and button.ConRODamageOverlays[id] then
		button.ConRODamageOverlays[id]:Hide();
	end
end

function ConRO:HideDefenseGlow(button, id)
	if button.ConRODefenseOverlays and button.ConRODefenseOverlays[id] then
		button.ConRODefenseOverlays[id]:Hide();
	end
end

function ConRO:HideCoolDownGlow(button, id)
	if button.ConROCoolDownOverlays and button.ConROCoolDownOverlays[id] then
		button.ConROCoolDownOverlays[id]:Hide();
	end
end

function ConRO:HideInterruptGlow(button, id)
	if button.ConROInterruptOverlays and button.ConROInterruptOverlays[id] then
		button.ConROInterruptOverlays[id]:Hide();
	end
end

function ConRO:HidePurgableGlow(button, id)
	if button.ConROPurgableOverlays and button.ConROPurgableOverlays[id] then
		button.ConROPurgableOverlays[id]:Hide();
	end
end

function ConRO:HideTauntGlow(button, id)
	if button.ConROTauntOverlays and button.ConROTauntOverlays[id] then
		button.ConROTauntOverlays[id]:Hide();
	end
end

function ConRO:HideRaidBuffsGlow(button, id)
	if button.ConRORaidBuffsOverlays and button.ConRORaidBuffsOverlays[id] then
		button.ConRORaidBuffsOverlays[id]:Hide();
	end
end

	
function ConRO:UpdateRotation()	
	self = ConRO;
	
	local isBartender = IsAddOnLoaded('Bartender4');
	local isElv = IsAddOnLoaded('ElvUI');
	
	if (isBartender) then
		self:FetchBartender4();
	elseif (isElv) then
		self:FetchElvUI();
	else
		self:FetchBlizzard();
	end

	if IsAddOnLoaded('ButtonForge') then
		self:FetchButtonForge();
	end
	
	if IsAddOnLoaded('Dominos') then
		self:FetchDominos();
	end
end

function ConRO:AddButton(spellID, button)
	if spellID then
		if self.Spells[spellID] == nil then
			self.Spells[spellID] = {};
		end
		tinsert(self.Spells[spellID], button);
		
		if self.Keybinds[spellID] == nil then
			self.Keybinds[spellID] = {};
		end

		tinsert(self.Keybinds[spellID], button);
	end
end

function ConRO:AddStandardButton(button)
	local type = button:GetAttribute('type');
	if type then
		local actionType = button:GetAttribute(type);
		local id;
		local spellId;

		if type == 'action' then
			local slot = button:GetAttribute('action') or ActionButton_GetPagedID(button) or ActionButton_CalculateAction(button) or 0;

			if HasAction(slot) then
				type, id = GetActionInfo(slot);
			else
				return;
			end
		end

		if type == 'macro' then
			spellId = GetMacroSpell(id);
			if not spellId then
				return;
			end
		elseif type == 'item' then
			spellId = GetItemInfo(id);
		elseif type == 'spell' then
			spellId = select(7, GetSpellInfo(id));
		end

		self:AddButton(spellId, button);
	end
end

function ConRO:DefAddButton(spellID, button)
	if spellID then
		if self.DefSpells[spellID] == nil then
			self.DefSpells[spellID] = {};
		end
		tinsert(self.DefSpells[spellID], button);
	end
end

function ConRO:DefAddStandardButton(button)
	local type = button:GetAttribute('type');
	if type then
		local actionType = button:GetAttribute(type);
		local id;
		local spellId;

		if type == 'action' then
			local slot = button:GetAttribute('action') or ActionButton_GetPagedID(button) or
				ActionButton_CalculateAction(button) or 0;

			if HasAction(slot) then
				type, actionType = GetActionInfo(slot);
			else
				return;
			end
		end

		if type == 'macro' then
			spellId = GetMacroSpell(actionType);
			if not spellId then
									   
	   
				return;
			end
		elseif type == 'item' then
			actionName = GetItemInfo(actionType);
		elseif type == 'spell' then
			spellId = select(7, GetSpellInfo(actionType));
		end

		self:DefAddButton(spellId, button);
	end
end

function ConRO:Fetch()
	self = ConRO;
	if self.rotationEnabled then
		self:DisableRotationTimer();
	end
	self.Spell = nil;

	self:GlowClear();
	self:WindowClear();
	self.Spells = {};
	self.Keybinds = {};
	self.Flags = {};
	self.SpellsGlowing = {};
	self.WindowsGlowing = {};
	
	local isBartender = IsAddOnLoaded('Bartender4');
	local isElv = IsAddOnLoaded('ElvUI');
	
	if (isBartender) then
		self:FetchBartender4();
	elseif (isElv) then
		self:FetchElvUI();
	else
		self:FetchBlizzard();
	end

	if IsAddOnLoaded('ButtonForge') then
		self:FetchButtonForge();
	end
	
	if IsAddOnLoaded('Dominos') then
		self:FetchDominos();
	end

	if self.rotationEnabled then
		self:EnableRotationTimer();
		self:InvokeNextSpell();
	end
end

function ConRO:FetchDef()
	self = ConRO;
	if self.defenseEnabled then
		self:DisableDefenseTimer();
	end
	self.Def = nil;

	self:GlowClearDef();
	self.DefSpells = {};
	self.Flags = {};
	self.DefGlowing = {};
	
	local isBartender = IsAddOnLoaded('Bartender4');
	local isElv = IsAddOnLoaded('ElvUI');
	
	if (isBartender) then
		self:DefFetchBartender4();
	elseif (isElv) then
		self:DefFetchElvUI();
	else
		self:DefFetchBlizzard();
	end

	if IsAddOnLoaded('ButtonForge') then
		self:DefFetchButtonForge();
	end
	
	if IsAddOnLoaded('Dominos') then
		self:DefFetchDominos();
	end

	if self.defenseEnabled then
		self:EnableDefenseTimer();
		self:InvokeNextDef();
	end
end

function ConRO:FetchBlizzard()
	local ActionBarsBlizzard = {'Action', 'MultiBarBottomLeft', 'MultiBarBottomRight', 'MultiBarRight', 'MultiBarLeft', 'Stance'};
	for _, barName in pairs(ActionBarsBlizzard) do
		if barName == 'Stance' then
			local x = GetNumShapeshiftForms();
			for i = 1, x do
				local button = _G[barName .. 'Button' .. i];
				local spellID = select(4, GetShapeshiftFormInfo(i));
				self:AddButton(spellID, button);
			end
		else
			for i = 1, 12 do
				local button = _G[barName .. 'Button' .. i];
				self:AddStandardButton(button);
			end
		end
	end
end

function ConRO:DefFetchBlizzard()
	local ActionBarsBlizzard = {'Action', 'MultiBarBottomLeft', 'MultiBarBottomRight', 'MultiBarRight', 'MultiBarLeft'};
	for _, barName in pairs(ActionBarsBlizzard) do
		for i = 1, 12 do
			local button = _G[barName .. 'Button' .. i];
			self:DefAddStandardButton(button);
		end
	end
end

--Only works for first 12 buttons, still can't figure out 13-60.
function ConRO:FetchDominos()
	for i = 1, 12 do
		local button = _G['DominosActionButton' .. i];
		if not button then
			break;
		end
		
		local slot = ActionButton_GetPagedID(button) or ActionButton_CalculateAction(button) or button:GetAttribute('action') or 0;
		if HasAction(slot) then
			local spellID, _;
			local actionType, id = GetActionInfo(slot);
			if actionType == 'macro' then id = GetMacroSpell(id) end
			if actionType == 'item' then
				spellID = GetItemInfo(id);
			elseif actionType == 'spell' or (actionType == 'macro' and id) then
				spellID = id;
			end
			if spellID then
				if self.Spells[spellID] == nil then
					self.Spells[spellID] = {};
				end

				tinsert(self.Spells[spellID], button);
				
				if self.Keybinds[spellID] == nil then
					self.Keybinds[spellID] = {};
				end
				
				tinsert(self.Keybinds[spellID], 'DominosActionButton' .. i);
									
			end
		end
	end
end

function ConRO:DefFetchDominos()
	for i = 1, 12 do
		local button = _G['DominosActionButton' .. i];
		if not button then
			break;
		end
		
		local slot = ActionButton_GetPagedID(button) or ActionButton_CalculateAction(button) or button:GetAttribute('action') or 0;
		if HasAction(slot) then
			local spellID, _;
			local actionType, id = GetActionInfo(slot);
			if actionType == 'macro' then id = GetMacroSpell(id) end
			if actionType == 'item' then
				spellID = GetItemInfo(id);
			elseif actionType == 'spell' or (actionType == 'macro' and id) then
				spellID = id;
			end
			if spellID then
				if self.DefSpells[spellID] == nil then
					self.DefSpells[spellID] = {};
				end

				tinsert(self.DefSpells[spellID], button);
			end
		end
	end
end

function ConRO:FetchButtonForge()
	local i = 1;
	while true do
		local button = _G['ButtonForge' .. i];
		if not button then
			break;
		end
		i = i + 1;

		local type = button:GetAttribute('type');
		if type then
			local actionType = button:GetAttribute(type);
			local id;
			local spellId;
			if type == 'macro' then
				local id = GetMacroSpell(actionType);
				if id then
					spellId = select(7, GetSpellInfo(id));
				end
			elseif type == 'item' then
				actionName = GetItemInfo(actionType);
			elseif type == 'spell' then
				spellId = select(7, GetSpellInfo(actionType));
			end
			if spellId then
				if self.Spells[spellId] == nil then
					self.Spells[spellId] = {};
				end

				tinsert(self.Spells[spellId], button);
				
				if self.Keybinds[spellId] == nil then
					self.Keybinds[spellId] = {};
				end
				
				tinsert(self.Keybinds[spellId], 'ButtonForge' .. i);
				 	
			end
		end
	end
end

function ConRO:DefFetchButtonForge()
	local i = 1;
	while true do
		local button = _G['ButtonForge' .. i];
		if not button then
			break;
		end
		i = i + 1;

		local type = button:GetAttribute('type');
		if type then
			local actionType = button:GetAttribute(type);
			local id;
			local spellId;
			if type == 'macro' then
				local id = GetMacroSpell(actionType);
				if id then
					spellId = select(7, GetSpellInfo(id));
				end
			elseif type == 'item' then
				actionName = GetItemInfo(actionType);
			elseif type == 'spell' then
				spellId = select(7, GetSpellInfo(actionType));
			end
			if spellId then
				if self.DefSpells[spellId] == nil then
					self.DefSpells[spellId] = {};
				end

				tinsert(self.DefSpells[spellId], button);
			end
		end
	end
end

function ConRO:FetchElvUI()
	local ret = false;
	for x = 1, 10 do
		for i = 1, 12 do
			local button = _G['ElvUI_Bar' .. x .. 'Button' .. i];
			if button then
				local spellId = button:GetSpellId();
				if spellId then
					local actionName, _ = GetSpellInfo(spellId);
					if spellId then
						if self.Spells[spellId] == nil then
							self.Spells[spellId] = {};
						end
						ret = true;
						tinsert(self.Spells[spellId], button);
						if self.Keybinds[spellId] == nil then
							self.Keybinds[spellId] = {};
						end
						
						tinsert(self.Keybinds[spellId], 'ElvUI_Bar' .. x .. 'Button' .. i);
						 	
					end
				end
			end
		end
	end
	return ret;
end

function ConRO:DefFetchElvUI()
	local ret = false;
	for x = 1, 10 do
		for i = 1, 12 do
			local button = _G['ElvUI_Bar' .. x .. 'Button' .. i];
			if button then
				local spellId = button:GetSpellId();
				if spellId then
					local actionName, _ = GetSpellInfo(spellId);
					if spellId then
						if self.DefSpells[spellId] == nil then
							self.DefSpells[spellId] = {};
						end
						ret = true;
						tinsert(self.DefSpells[spellId], button);
					end
				end
			end
		end
	end
	return ret;
end

function ConRO:FetchBartender4()
	local ret = false;
	for i = 1, 120 do
		local button = _G['BT4Button' .. i];
		if button then
			local spellId = button:GetSpellId();
			if spellId then
				local actionName, _ = GetSpellInfo(spellId);
				if spellId then
					if self.Spells[spellId] == nil then
						self.Spells[spellId] = {};
					end
					ret = true;
					tinsert(self.Spells[spellId], button);
					if self.Keybinds[spellId] == nil then
						self.Keybinds[spellId] = {};
					end
					
					tinsert(self.Keybinds[spellId], 'BT4Button' .. i); 	
				end
			end
		end
	end
	return ret;
end

function ConRO:DefFetchBartender4()
	local ret = false;
	for i = 1, 120 do
		local button = _G['BT4Button' .. i];
		if button then
			local spellId = button:GetSpellId();
			if spellId then
				local actionName, _ = GetSpellInfo(spellId);
				if spellId then
					if self.DefSpells[spellId] == nil then
						self.DefSpells[spellId] = {};
					end
					ret = true;
					tinsert(self.DefSpells[spellId], button);
				end
			end
		end
	end
	return ret;
end

function ConRO:Dump()
	local s = '';
	for k, v in pairs(self.Spells) do
		s = s .. ', ' .. k;
	end
	print(s);
end

function ConRO:FindSpell(spellID)
	return self.Spells[spellID];
end

function ConRO:AbilityBurstIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:CoolDownGlow(button, id);
		end
	end
end

function ConRO:ClearAbilityBurstIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:HideCoolDownGlow(button, id);
		end
	end
end

function ConRO:AbilityInterruptIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:InterruptGlow(button, id);
		end
	end
end

function ConRO:ClearAbilityInterruptIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:HideInterruptGlow(button, id);
		end
	end
end

function ConRO:AbilityPurgeIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:PurgableGlow(button, id);
		end
	end
end

function ConRO:AbilityTauntIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:TauntGlow(button, id);
		end
	end
end

function ConRO:ClearAbilityPurgeIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:HidePurgableGlow(button, id);
		end
	end
end

function ConRO:ClearAbilityTauntIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:HideTauntGlow(button, id);
		end
	end
end

function ConRO:AbilityRaidBuffsIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:RaidBuffsGlow(button, id);
		end
	end
end

function ConRO:ClearAbilityRaidBuffsIndependent(spellID, id)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:HideRaidBuffsGlow(button, id);
		end
	end
end

function ConRO:AbilityBurst(spell, condition)
	local incombat = UnitAffectingCombat('player');
	
	if self.Flags[spell] == nil then
		self.Flags[spell] = false;
	end
	if condition and not self.Flags[spell] then
		self.Flags[spell] = true;
		self:AbilityBurstIndependent(spell, spell);
	end
	if not condition and self.Flags[spell] then
		self.Flags[spell] = false;
		self:ClearAbilityBurstIndependent(spell, spell);
	end
end

function ConRO:AbilityInterrupt(spell, condition)
	if self.Flags[spell] == nil then
		self.Flags[spell] = false;
	end
	if condition and not self.Flags[spell] then
		self.Flags[spell] = true;
		self:AbilityInterruptIndependent(spell, spell);
	end
	if not condition and self.Flags[spell] then
		self.Flags[spell] = false;
		self:ClearAbilityInterruptIndependent(spell, spell);
	end
end

function ConRO:AbilityPurge(spell, condition)
	if self.Flags[spell] == nil then
		self.Flags[spell] = false;
	end
	if condition and not self.Flags[spell] then
		self.Flags[spell] = true;
		self:AbilityPurgeIndependent(spell, spell);
	end
	if not condition and self.Flags[spell] then
		self.Flags[spell] = false;
		self:ClearAbilityPurgeIndependent(spell, spell);
	end
end

function ConRO:AbilityTaunt(spell, condition)
	if self.Flags[spell] == nil then
		self.Flags[spell] = false;
	end
	if condition and not self.Flags[spell] then
		self.Flags[spell] = true;
		self:AbilityTauntIndependent(spell, spell);
	end
	if not condition and self.Flags[spell] then
		self.Flags[spell] = false;
		self:ClearAbilityTauntIndependent(spell, spell);
	end
end

function ConRO:AbilityRaidBuffs(spell, condition)
	if self.Flags[spell] == nil then
		self.Flags[spell] = false;
	end
	if condition and not self.Flags[spell] then
		self.Flags[spell] = true;
		self:AbilityRaidBuffsIndependent(spell, spell);
	end
	if not condition and self.Flags[spell] then
		self.Flags[spell] = false;
		self:ClearAbilityRaidBuffsIndependent(spell, spell);
	end
end

function ConRO:WindowSpell(spellID)
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:WindowGlow(button, spellID);
		end
		self.WindowsGlowing[spellID] = 1;
	end
end

function ConRO:GlowSpell(spellID)
	local spellName = GetSpellInfo(spellID);
	if self.Spells[spellID] ~= nil then
		for k, button in pairs(self.Spells[spellID]) do
			self:DamageGlow(button, 'next');
		end
		self.SpellsGlowing[spellID] = 1;
	else
		self:Print(self.Colors.Error .. 'Spell not found on action bars: ' .. ' ' .. spellName .. '(' .. spellID .. ')');
	end
end

function ConRO:GlowDef(spellID)
	local spellName = GetSpellInfo(spellID);
	if self.DefSpells[spellID] ~= nil then
		for k, button in pairs(self.DefSpells[spellID]) do
			self:DefenseGlow(button, 'nextdef');
		end
		self.DefGlowing[spellID] = 1;
	else
		self:Print(self.Colors.Error .. 'Spell not found on action bars: ' .. ' ' .. spellName .. '(' .. spellID .. ')');
	end
end

function ConRO:GlowNextWindow(spellID)
	self:WindowClear();
	self:WindowSpell(spellID);
end

function ConRO:GlowNextSpell(spellID)
	self:GlowClear();
	self:GlowSpell(spellID);
end

function ConRO:GlowNextDef(spellID)
	self:GlowClearDef();
	self:GlowDef(spellID);
end

function ConRO:WindowClear()
	for spellID, v in pairs(self.WindowsGlowing) do
		if v == 1 then
			for k, button in pairs(self.Spells[spellID]) do
				self:HideWindowGlow(button, spellID);
			end
			self.WindowsGlowing[spellID] = 0;
		end
	end
end

function ConRO:GlowClear()
	for spellID, v in pairs(self.SpellsGlowing) do
		if v == 1 then
			for k, button in pairs(self.Spells[spellID]) do
				self:HideDamageGlow(button, 'next');
			end
			self.SpellsGlowing[spellID] = 0;
		end
	end
end

function ConRO:GlowClearDef()
	for spellID, v in pairs(self.DefGlowing) do
		if v == 1 then
			for k, button in pairs(self.DefSpells[spellID]) do
				self:HideDefenseGlow(button, 'nextdef');
			end
			self.DefGlowing[spellID] = 0;
		end
	end
end

local function TTOnEnter(self)
  GameTooltip:SetOwner(self, "ConROButtonFrame")
  GameTooltip:SetText("tooltipTitle")  -- This sets the top line of text, in gold.
  GameTooltip:AddLine("This is the contents of my tooltip", 1, 1, 1)
  GameTooltip:Show()
end

local function TTOnLeave(self)
  GameTooltip:Hide()
end